﻿using System;
using Syncfusion.EJ.ReportViewer;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using Syncfusion.Reports.EJ;
using System.Collections;
using ReportViewerDemo;
using System.Data;

namespace jssample
{
    public class ReportApiController : ApiController, IReportController
    {
        //Post action for processing the rdl/rdlc report
        public object PostReportAction(Dictionary<string, object> jsonResult)
        {
            return ReportHelper.ProcessReport(jsonResult, this);
        }

        //Get action for getting resources from the report
        [System.Web.Http.ActionName("GetResource")]
        [AcceptVerbs("GET")]
        public object GetResource(string key, string resourcetype, bool isPrint)
        {
            return ReportHelper.GetResource(key, resourcetype, isPrint);
        }

        //Method will be called when initialize the report options before start processing the report        
        public void OnInitReportOptions(ReportViewerOptions reportOption)
        {
            if (reportOption.ReportModel.ReportPath.Contains("Report1"))
            {
                reportOption.ReportModel.DataSources.Add(new ReportDataSource { Name = "DataSet1", Value = this.FillReport() });
            }
            reportOption.ReportModel.ReportPath = System.Web.HttpContext.Current.Server.MapPath("~/" + reportOption.ReportModel.ReportPath);
        }

        //Method will be called when reported is loaded
        public void OnReportLoaded(ReportViewerOptions reportOption)
        {

        }

        private DataSet FillReport()
        {
            DataSet1 inmueblerpt = new DataSet1();
            DataSet1.INMUEBLESRow dsinmueble = inmueblerpt.INMUEBLES.NewINMUEBLESRow();

            dsinmueble.ACTIVO = "15";
            dsinmueble.CERRADO = "100";
            dsinmueble.FORMACION = "20";
            dsinmueble.TRASLADO = "100";

            int total = Convert.ToInt32(dsinmueble.ACTIVO) + Convert.ToInt32(dsinmueble.CERRADO) + Convert.ToInt32(dsinmueble.FORMACION) + Convert.ToInt32(dsinmueble.TRASLADO);
            dsinmueble.TOTAL = Convert.ToString(total);

            inmueblerpt.INMUEBLES.Rows.Add(dsinmueble);

            return inmueblerpt;
        }
    }
}